
/* A Bison parser, made from parser.y
   by GNU bison 1.29.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	TK_DOC	257
# define	TK_EXPORTEDDOC	258
# define	TK_MAKEFILE	259
# define	TK_VARCODE	260
# define	TK_POSTINITCODE	261
# define	TK_CPPCODE	262
# define	TK_PREPYCODE	263
# define	TK_PYCODE	264
# define	TK_COPYING	265
# define	TK_MAPPEDTYPE	266
# define	TK_CODEBLOCK	267
# define	TK_IF	268
# define	TK_END	269
# define	TK_NAME	270
# define	TK_FILENAME	271
# define	TK_STRING	272
# define	TK_VIRTUALCODE	273
# define	TK_MEMBERCODE	274
# define	TK_FROMTYPE	275
# define	TK_TOTYPE	276
# define	TK_TOSUBCLASS	277
# define	TK_INCLUDE	278
# define	TK_OPTINCLUDE	279
# define	TK_IMPORT	280
# define	TK_HEADERCODE	281
# define	TK_EXPHEADERCODE	282
# define	TK_MODULE	283
# define	TK_CLASS	284
# define	TK_STRUCT	285
# define	TK_PUBLIC	286
# define	TK_PROTECTED	287
# define	TK_PRIVATE	288
# define	TK_SIGNALS	289
# define	TK_SLOTS	290
# define	TK_BOOL	291
# define	TK_SHORT	292
# define	TK_INT	293
# define	TK_LONG	294
# define	TK_FLOAT	295
# define	TK_DOUBLE	296
# define	TK_CHAR	297
# define	TK_VOID	298
# define	TK_PYOBJECT	299
# define	TK_VIRTUAL	300
# define	TK_ENUM	301
# define	TK_UNSIGNED	302
# define	TK_SCOPE	303
# define	TK_LOGICAL_OR	304
# define	TK_CONST	305
# define	TK_STATIC	306
# define	TK_SIPSIGNAL	307
# define	TK_SIPRXCON	308
# define	TK_SIPRXDIS	309
# define	TK_SIPSLOTCON	310
# define	TK_SIPSLOTDIS	311
# define	TK_NUMBER	312
# define	TK_REAL	313
# define	TK_TYPEDEF	314
# define	TK_NAMESPACE	315
# define	TK_TIMELINE	316
# define	TK_PLATFORMS	317
# define	TK_FEATURE	318
# define	TK_LICENSE	319
# define	TK_EXPOSE	320
# define	TK_QCHAR	321

#line 24 "parser.y"

#include <stdlib.h>
#include <string.h>

#include "sip.h"


#define	MAX_NESTED_IF		10
#define	MAX_NESTED_SCOPE	10

#define	isMainModule(m)		(currentSpec -> module == (m))


/* The different attribute name types. */

typedef enum {
	func_attr,
	var_attr,
	enum_attr,
	class_attr
} attrType;


static sipSpec *currentSpec;		/* The current spec being parsed. */
static stringList *neededQualifiers;	/* The list of required qualifiers. */
static stringList *excludedQualifiers;	/* The list of excluded qualifiers. */
static moduleDef *currentModule;	/* The current module being parsed. */
static mappedTypeDef *currentMappedType;	/* The current mapped type. */
static enumDef *currentEnum;		/* The current enum being parsed. */
static int sectionFlags;		/* The current section flags. */
static int currentOverIsVirt;		/* Set if the overload is virtual. */
static int currentIsStatic;		/* Set if the current is static. */
static char *previousFile;		/* The file just parsed. */
static parserContext newContext;	/* The new pending context. */
static int skipStackPtr;		/* The skip stack pointer. */
static int skipStack[MAX_NESTED_IF];	/* Stack of skip flags. */
static classDef *scopeStack[MAX_NESTED_SCOPE];	/* The scope stack. */
static int sectFlagsStack[MAX_NESTED_SCOPE];	/* The section flags stack. */
static int currentScopeIdx;		/* The scope stack index. */


static nameDef *cacheName(sipSpec *,moduleDef *,char *);
static ifaceFileDef *findIfaceFile(sipSpec *,scopedNameDef *,ifaceFileType,
				   argDef *);
static classDef *findClass(sipSpec *,ifaceFileType,scopedNameDef *);
static classDef *newClass(sipSpec *,ifaceFileType,scopedNameDef *);
static void finishClass(classDef *,optFlags *);
static mappedTypeDef *newMappedType(sipSpec *,argDef *);
static enumDef *newEnum(sipSpec *,moduleDef *,char *,int);
static void newTypedef(sipSpec *,char *,argDef *);
static void newVar(sipSpec *,moduleDef *,char *,int,argDef *,codeBlock *);
static void newCtor(char *,int,funcArgs *,codeBlock *);
static void newFunction(sipSpec *,moduleDef *,int,int,int,
			argDef *,char *,funcArgs *,int,int,optFlags *,
			codeBlock *,codeBlock *);
static optFlag *findOptFlag(optFlags *,char *,flagType);
static memberDef *findFunction(sipSpec *,moduleDef *,classDef *,char *);
static void checkAttributes(sipSpec *,classDef *,nameDef *,attrType);
static void newModule(FILE *,char *);
static void appendCodeBlock(codeBlock **,codeBlock *);
static void parseFile(FILE *,char *,moduleDef *,int);
static void handleEOF(void);
static void handleEOM(void);
static qualDef *findQualifier(sipSpec *,char *);
static scopedNameDef *text2scopedName(char *);
static void pushScope(classDef *);
static void popScope(void);
static classDef *currentScope(void);
static void newQualifier(sipSpec *,moduleDef *,int,char *,qualType);
static void newImport(sipSpec *,char *);
static void usedInMainModule(sipSpec *,ifaceFileDef *);
static int timePeriod(sipSpec *,char *,char *);
static int platOrFeature(sipSpec *,char *,int);
static int isExcluded(qualDef *qd);
static int isNeeded(qualDef *);
static int notSkipping(void);

#line 102 "parser.y"
typedef union {
	char		qchar;
	char		*text;
	long		number;
	double		real;
	argDef		memArg;
	funcArgs	arglist;
	codeBlock	*codeb;
	valueDef	value;
	valueDef	*valp;
	optFlags	optflags;
	optFlag		flag;
	scopedNameDef	*scpvalp;
	fcallDef	fcall;
	int		boolean;
} YYSTYPE;
#include <stdio.h>



#define	YYFINAL		346
#define	YYFLAG		-32768
#define	YYNTBASE	86

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 321 ? yytranslate[x] : 183)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    73,     2,     2,     2,     2,    82,     2,
      71,    72,    83,    77,    75,    74,     2,    81,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    80,    70,
      84,    76,    85,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    68,    78,    69,    79,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67
};

#if YYDEBUG != 0
static const short yyprhs[] =
{
       0,     0,     2,     5,     6,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    35,    37,
      39,    41,    43,    45,    47,    49,    51,    53,    55,    57,
      59,    61,    63,    65,    67,    69,    71,    72,    80,    82,
      85,    87,    90,    93,    94,   102,   104,   107,   108,   114,
     116,   119,   121,   124,   125,   131,   133,   136,   138,   143,
     145,   148,   152,   157,   159,   163,   165,   168,   171,   174,
     177,   180,   183,   184,   187,   190,   193,   196,   199,   202,
     205,   208,   211,   214,   219,   222,   223,   231,   232,   234,
     235,   237,   239,   242,   244,   246,   250,   251,   253,   254,
     257,   259,   263,   265,   267,   269,   270,   272,   274,   276,
     278,   281,   283,   287,   289,   291,   296,   298,   300,   302,
     304,   305,   307,   311,   316,   320,   321,   330,   331,   341,
     342,   345,   347,   351,   353,   355,   358,   360,   362,   364,
     366,   368,   370,   372,   374,   376,   378,   380,   382,   385,
     388,   392,   396,   400,   403,   404,   406,   413,   421,   433,
     434,   436,   437,   440,   441,   445,   447,   451,   453,   457,
     459,   461,   463,   464,   467,   468,   471,   473,   474,   476,
     480,   482,   484,   486,   491,   496,   499,   500,   504,   506,
     508,   510,   511,   515,   517,   522,   527,   531,   534,   535,
     537,   538,   541,   543,   548,   551,   554,   556,   558,   561,
     563,   565,   568,   570,   572,   574,   577,   579,   581,   583,
     585
};
static const short yyrhs[] =
{
      87,     0,    86,    87,     0,     0,    88,    89,     0,   113,
       0,   118,     0,   114,     0,   115,     0,   116,     0,   103,
       0,    98,     0,   102,     0,   111,     0,   112,     0,   119,
       0,   120,     0,   121,     0,   122,     0,   123,     0,   124,
       0,   125,     0,   126,     0,   127,     0,    91,     0,    90,
       0,   107,     0,   110,     0,    95,     0,   147,     0,   149,
       0,   146,     0,   145,     0,   129,     0,   159,     0,   176,
       0,     0,    12,   181,    92,    68,    93,    69,    70,     0,
      94,     0,    93,    94,     0,   119,     0,    21,   128,     0,
      22,   128,     0,     0,    61,    16,    96,    68,    97,    69,
      70,     0,    90,     0,    97,    90,     0,     0,    63,    99,
      68,   100,    69,     0,   101,     0,   100,   101,     0,    16,
       0,    64,    16,     0,     0,    62,   104,    68,   105,    69,
       0,   106,     0,   105,   106,     0,    16,     0,    14,    71,
     109,    72,     0,    16,     0,    73,    16,     0,   108,    50,
      16,     0,   108,    50,    73,    16,     0,   108,     0,   132,
      74,   132,     0,    15,     0,    65,   162,     0,    66,    16,
       0,    29,    16,     0,    24,    17,     0,    25,    17,     0,
      26,    17,     0,     0,     6,   128,     0,    11,   128,     0,
      27,   128,     0,    28,   128,     0,     8,   128,     0,     7,
     128,     0,     9,   128,     0,    10,   128,     0,     3,   128,
       0,     4,   128,     0,     5,    17,   131,   128,     0,    13,
      15,     0,     0,    47,   132,   130,    68,   133,    69,    70,
       0,     0,    17,     0,     0,    16,     0,   134,     0,   133,
     134,     0,   107,     0,   110,     0,    16,   136,   135,     0,
       0,    75,     0,     0,    76,   137,     0,   140,     0,   137,
     138,   140,     0,    74,     0,    77,     0,    78,     0,     0,
      73,     0,    79,     0,    74,     0,    77,     0,   139,   143,
       0,   142,     0,   141,    49,   142,     0,    16,     0,   141,
       0,   141,    71,   144,    72,     0,    59,     0,    58,     0,
      18,     0,    67,     0,     0,   140,     0,   144,    75,   140,
       0,    60,   177,    16,    70,     0,    30,   141,    70,     0,
       0,    31,    16,   148,   162,    68,   154,    69,    70,     0,
       0,    30,    16,   150,   151,   162,    68,   154,    69,    70,
       0,     0,    80,   152,     0,   153,     0,   152,    75,   153,
       0,   141,     0,   155,     0,   154,   155,     0,   107,     0,
     110,     0,    95,     0,   149,     0,   146,     0,   145,     0,
     129,     0,   121,     0,   119,     0,   158,     0,   157,     0,
     171,     0,    23,   128,     0,    22,   128,     0,    32,   156,
      80,     0,    33,   156,    80,     0,    34,   156,    80,     0,
      35,    80,     0,     0,    36,     0,    79,    16,    71,    72,
      70,   166,     0,    16,    71,   168,    72,   162,    70,   166,
       0,   177,    16,    71,   168,    72,   160,   161,   162,    70,
     166,   167,     0,     0,    51,     0,     0,    76,    58,     0,
       0,    81,   163,    81,     0,   164,     0,   163,    75,   164,
       0,    16,     0,    16,    76,   165,     0,    16,     0,    18,
       0,    58,     0,     0,    20,   128,     0,     0,    19,   128,
       0,   169,     0,     0,   170,     0,   169,    75,   170,     0,
      53,     0,    54,     0,    55,     0,    56,    71,   168,    72,
       0,    57,    71,   168,    72,     0,   178,   136,     0,     0,
      52,   172,   173,     0,   173,     0,   174,     0,   176,     0,
       0,    46,   175,   159,     0,   159,     0,   177,    16,    70,
     117,     0,    51,   181,   180,   179,     0,   181,   180,   179,
       0,   177,   162,     0,     0,    82,     0,     0,   180,    83,
       0,   141,     0,   141,    84,   182,    85,     0,    31,   141,
       0,    48,    38,     0,    38,     0,    48,     0,    48,    39,
       0,    39,     0,    40,     0,    48,    40,     0,    41,     0,
      42,     0,    37,     0,    48,    43,     0,    43,     0,    44,
       0,    45,     0,   181,     0,   182,    75,   181,     0
};

#endif

#if YYDEBUG != 0
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   223,   224,   227,   244,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   260,   261,   265,   266,
     267,   268,   269,   270,   271,   272,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   287,   296,   310,   311,
     314,   318,   327,   338,   351,   359,   360,   363,   370,   390,
     391,   394,   399,   404,   410,   430,   431,   434,   439,   454,
     457,   460,   463,   468,   469,   474,   480,   507,   530,   543,
     548,   553,   558,   561,   566,   572,   577,   582,   587,   593,
     599,   605,   611,   616,   638,   641,   649,   652,   655,   660,
     663,   668,   669,   672,   673,   674,   701,   702,   705,   708,
     713,   714,   732,   735,   738,   743,   746,   749,   752,   755,
     760,   778,   779,   784,   789,   799,   809,   813,   817,   821,
     827,   832,   838,   856,   862,   876,   890,   899,   913,   922,
     923,   926,   927,   930,   945,   946,   949,   950,   951,   952,
     953,   954,   955,   956,   960,   964,   965,   966,   967,   978,
     989,   993,   997,  1001,  1007,  1010,  1015,  1035,  1048,  1066,
    1069,  1074,  1077,  1085,  1088,  1094,  1098,  1110,  1114,  1120,
    1124,  1128,  1134,  1137,  1142,  1145,  1150,  1208,  1213,  1219,
    1251,  1258,  1265,  1272,  1282,  1292,  1298,  1299,  1299,  1302,
    1303,  1306,  1307,  1307,  1310,  1331,  1336,  1343,  1384,  1387,
    1392,  1395,  1400,  1404,  1414,  1418,  1421,  1424,  1427,  1430,
    1433,  1436,  1439,  1442,  1445,  1448,  1451,  1454,  1457,  1462,
    1468
};
#endif


#if YYDEBUG != 0 || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "TK_DOC", "TK_EXPORTEDDOC", "TK_MAKEFILE", 
  "TK_VARCODE", "TK_POSTINITCODE", "TK_CPPCODE", "TK_PREPYCODE", 
  "TK_PYCODE", "TK_COPYING", "TK_MAPPEDTYPE", "TK_CODEBLOCK", "TK_IF", 
  "TK_END", "TK_NAME", "TK_FILENAME", "TK_STRING", "TK_VIRTUALCODE", 
  "TK_MEMBERCODE", "TK_FROMTYPE", "TK_TOTYPE", "TK_TOSUBCLASS", 
  "TK_INCLUDE", "TK_OPTINCLUDE", "TK_IMPORT", "TK_HEADERCODE", 
  "TK_EXPHEADERCODE", "TK_MODULE", "TK_CLASS", "TK_STRUCT", "TK_PUBLIC", 
  "TK_PROTECTED", "TK_PRIVATE", "TK_SIGNALS", "TK_SLOTS", "TK_BOOL", 
  "TK_SHORT", "TK_INT", "TK_LONG", "TK_FLOAT", "TK_DOUBLE", "TK_CHAR", 
  "TK_VOID", "TK_PYOBJECT", "TK_VIRTUAL", "TK_ENUM", "TK_UNSIGNED", 
  "TK_SCOPE", "TK_LOGICAL_OR", "TK_CONST", "TK_STATIC", "TK_SIPSIGNAL", 
  "TK_SIPRXCON", "TK_SIPRXDIS", "TK_SIPSLOTCON", "TK_SIPSLOTDIS", 
  "TK_NUMBER", "TK_REAL", "TK_TYPEDEF", "TK_NAMESPACE", "TK_TIMELINE", 
  "TK_PLATFORMS", "TK_FEATURE", "TK_LICENSE", "TK_EXPOSE", "TK_QCHAR", 
  "'{'", "'}'", "';'", "'('", "')'", "'!'", "'-'", "','", "'='", "'+'", 
  "'|'", "'~'", "':'", "'/'", "'&'", "'*'", "'<'", "'>'", "specification", 
  "statement", "@1", "modstatement", "nsstatement", "mappedtype", "@2", 
  "mtbody", "mtline", "namespace", "@3", "nsbody", "platforms", "@4", 
  "platformlist", "platform", "feature", "timeline", "@5", 
  "qualifierlist", "qualifiername", "ifstart", "oredqualifiers", 
  "qualifiers", "ifend", "license", "expose", "module", "include", 
  "optinclude", "import", "optvarcode", "copying", "hdrcode", 
  "exphdrcode", "cppcode", "postinitcode", "prepycode", "pycode", "doc", 
  "exporteddoc", "makefile", "codeblock", "enum", "@6", "optfilename", 
  "optname", "enumbody", "enumline", "optcomma", "optassign", "expr", 
  "binop", "optunop", "value", "scopedname", "scopepart", "simplevalue", 
  "valuelist", "typedef", "opaqueclass", "struct", "@7", "class", "@8", 
  "superclasses", "superlist", "superclass", "classbody", "classline", 
  "optslot", "dtor", "ctor", "function", "optconst", "optabstract", 
  "optflags", "flaglist", "flag", "flagvalue", "membercode", 
  "optvirtualcode", "arglist", "rawarglist", "argvalue", "varmember", 
  "@9", "varmem", "member", "@10", "variable", "cpptype", "argtype", 
  "optref", "deref", "basetype", "basetypelist", NULL
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    86,    86,    88,    87,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    89,    89,    89,    89,
      89,    89,    89,    89,    89,    89,    90,    90,    90,    90,
      90,    90,    90,    90,    90,    90,    92,    91,    93,    93,
      94,    94,    94,    96,    95,    97,    97,    99,    98,   100,
     100,   101,   102,   104,   103,   105,   105,   106,   107,   108,
     108,   108,   108,   109,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   130,   129,   131,   131,   132,
     132,   133,   133,   134,   134,   134,   135,   135,   136,   136,
     137,   137,   138,   138,   138,   139,   139,   139,   139,   139,
     140,   141,   141,   142,   143,   143,   143,   143,   143,   143,
     144,   144,   144,   145,   146,   148,   147,   150,   149,   151,
     151,   152,   152,   153,   154,   154,   155,   155,   155,   155,
     155,   155,   155,   155,   155,   155,   155,   155,   155,   155,
     155,   155,   155,   155,   156,   156,   157,   158,   159,   160,
     160,   161,   161,   162,   162,   163,   163,   164,   164,   165,
     165,   165,   166,   166,   167,   167,   168,   169,   169,   169,
     170,   170,   170,   170,   170,   170,   172,   171,   171,   173,
     173,   175,   174,   174,   176,   177,   177,   178,   179,   179,
     180,   180,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   182,
     182
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     2,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     7,     1,     2,
       1,     2,     2,     0,     7,     1,     2,     0,     5,     1,
       2,     1,     2,     0,     5,     1,     2,     1,     4,     1,
       2,     3,     4,     1,     3,     1,     2,     2,     2,     2,
       2,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     4,     2,     0,     7,     0,     1,     0,
       1,     1,     2,     1,     1,     3,     0,     1,     0,     2,
       1,     3,     1,     1,     1,     0,     1,     1,     1,     1,
       2,     1,     3,     1,     1,     4,     1,     1,     1,     1,
       0,     1,     3,     4,     3,     0,     8,     0,     9,     0,
       2,     1,     3,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       3,     3,     3,     2,     0,     1,     6,     7,    11,     0,
       1,     0,     2,     0,     3,     1,     3,     1,     3,     1,
       1,     1,     0,     2,     0,     2,     1,     0,     1,     3,
       1,     1,     1,     4,     4,     2,     0,     3,     1,     1,
       1,     0,     3,     1,     4,     4,     3,     2,     0,     1,
       0,     2,     1,     4,     2,     2,     1,     1,     2,     1,
       1,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       3,     3,     1,     0,     2,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    65,   113,     0,     0,     0,
       0,     0,     0,     0,     0,   214,   206,   209,   210,   212,
     213,   216,   217,   218,    89,   207,     0,     0,     0,    53,
      47,     0,   163,     0,     4,    25,    24,    28,    11,    12,
      10,    26,    27,    13,    14,     5,     7,     8,     9,     6,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    33,
     202,   111,    32,    31,    29,    30,    34,    35,     0,   200,
       0,    81,    82,    87,    78,    77,    79,    80,    74,     0,
      36,    89,    69,    70,    71,    75,    76,    68,   127,     0,
     113,   204,    90,    85,   205,   208,   211,   215,   200,     0,
      43,     0,     0,    52,     0,    66,    67,     0,     0,     0,
     198,    84,    88,     0,     0,    59,     0,    63,     0,     0,
     129,   124,   163,     0,   198,     0,     0,     0,     0,   167,
       0,   165,   112,   219,     0,    72,   177,   199,   201,   196,
      83,     0,    60,     0,    58,    89,     0,   163,     0,     0,
     195,   123,     0,    57,     0,    55,    51,     0,    49,     0,
       0,   164,     0,   203,     0,   194,   180,   181,   182,     0,
       0,     0,   176,   178,   163,    98,     0,     0,     0,    38,
      40,    61,     0,    64,   133,   130,   131,     0,     0,    98,
      93,    94,     0,    91,    45,     0,    54,    56,    48,    50,
     169,   170,   171,   168,   166,   220,    73,   177,   177,   159,
       0,   197,   105,   185,    41,    42,     0,    39,    62,     0,
       0,   113,     0,     0,   154,   154,   154,     0,   191,   186,
       0,   138,   136,   137,   144,   143,   142,   141,   140,   139,
       0,   134,   146,   145,   193,   147,   188,   189,   190,    96,
       0,    92,     0,    46,     0,     0,   160,   161,   179,   106,
     108,   109,   107,    99,     0,   100,    37,   132,     0,   177,
     149,   148,   155,     0,     0,     0,   153,     0,     0,     0,
       0,   135,    97,    95,    86,    44,   183,   184,     0,   163,
     102,   103,   104,   105,   118,   117,   116,   119,   114,   110,
       0,     0,   150,   151,   152,   192,     0,   187,     0,   126,
     162,     0,   101,   105,   128,   163,     0,     0,   172,   121,
       0,     0,   172,     0,   174,   115,   105,   172,   156,   173,
       0,   158,   122,   157,   175,     0,     0
};

static const short yydefgoto[] =
{
       1,     2,     3,    44,    45,    46,   124,   188,   189,   241,
     136,   205,    48,   112,   167,   168,    49,    50,   111,   164,
     165,   242,   127,   128,   243,    53,    54,    55,    56,    57,
      58,   175,    59,   244,    61,   245,    63,    64,    65,    66,
      67,    68,    81,   246,   133,   123,   103,   202,   203,   293,
     223,   273,   303,   274,   275,    70,    71,   309,   330,   247,
     248,    74,   132,   249,   130,   157,   195,   196,   250,   251,
     283,   252,   253,   254,   267,   299,   115,   140,   141,   213,
     334,   341,   181,   182,   183,   255,   288,   256,   257,   287,
     258,    78,   185,   149,   120,    79,   144
};

static const short yypact[] =
{
  -32768,    35,-32768,   357,-32768,    46,    46,    11,    46,    46,
      46,    46,    46,   474,   -24,-32768,-32768,    73,    95,   103,
      46,    46,   120,   134,   139,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,   151,   118,   474,   192,   167,-32768,
  -32768,   172,    53,   177,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
      32,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   178,-32768,
     180,-32768,-32768,   184,-32768,-32768,-32768,-32768,-32768,   189,
  -32768,     5,-32768,-32768,-32768,-32768,-32768,-32768,   -19,    40,
      28,   157,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   191,
  -32768,   142,   143,-32768,   200,-32768,-32768,   189,   474,   -27,
      81,-32768,-32768,    46,   156,   154,   223,   197,   169,   168,
     170,-32768,    53,   181,    81,   185,   186,   232,   240,   190,
     -39,-32768,-32768,-32768,    66,   273,   428,-32768,-32768,-32768,
  -32768,   127,-32768,     6,-32768,   151,   189,    53,   212,   171,
  -32768,-32768,   395,-32768,    24,-32768,-32768,    25,-32768,    85,
     200,-32768,   474,-32768,    46,-32768,-32768,-32768,-32768,   213,
     215,   211,   214,-32768,    53,   216,    46,    46,    64,-32768,
  -32768,-32768,   271,-32768,   157,   218,-32768,   220,   298,   216,
  -32768,-32768,    18,-32768,-32768,    84,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,   428,   428,   243,
     428,-32768,    34,-32768,-32768,-32768,   225,-32768,-32768,   189,
     298,   226,    46,    46,   260,   260,   260,   221,-32768,-32768,
     282,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
      23,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   227,
     233,-32768,   234,-32768,   228,   235,-32768,   229,-32768,-32768,
  -32768,-32768,-32768,    96,    79,-32768,-32768,-32768,   230,   428,
  -32768,-32768,-32768,   231,   236,   237,-32768,   192,   458,   239,
     238,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   257,    53,
  -32768,-32768,-32768,    34,-32768,-32768,-32768,-32768,    33,-32768,
     248,   247,-32768,-32768,-32768,-32768,   306,-32768,   251,-32768,
  -32768,   254,-32768,   125,-32768,    53,   255,   277,   328,-32768,
      90,   281,   328,    46,   333,-32768,    34,   328,-32768,-32768,
      46,-32768,-32768,-32768,-32768,   353,-32768
};

static const short yypgoto[] =
{
  -32768,   354,-32768,-32768,  -133,-32768,-32768,-32768,   166,     9,
  -32768,-32768,-32768,-32768,-32768,   196,-32768,-32768,-32768,-32768,
     193,     7,-32768,-32768,    13,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,     8,-32768,   367,-32768,-32768,-32768,-32768,
  -32768,-32768,    -6,    14,-32768,-32768,   -78,-32768,   173,-32768,
     175,-32768,-32768,-32768,  -184,   -16,   259,-32768,-32768,    15,
      16,-32768,-32768,    17,-32768,-32768,-32768,   149,   126,  -198,
    -130,-32768,-32768,    -2,-32768,-32768,  -108,-32768,   209,-32768,
    -190,-32768,  -191,-32768,   160,-32768,-32768,   101,-32768,-32768,
      20,   -28,-32768,   256,   283,    12,-32768
};


#define	YYLAST		522


static const short yytable[] =
{
      82,    76,    84,    85,    86,    87,    88,    99,   101,   109,
      51,    60,    47,   129,    95,    96,    52,    69,    72,    73,
      75,   125,   191,    77,   158,    90,   264,   265,    83,   204,
    -113,     9,    14,    15,   199,   345,   170,    14,    15,   231,
     163,   166,   171,   145,   146,   232,   233,    91,   108,   197,
      20,  -113,   291,    23,    89,   234,   235,   236,   237,    80,
      25,    26,    27,    28,    29,    30,    31,    32,    33,   238,
      34,    35,   263,   101,    36,   239,   221,   193,   126,   192,
     291,   117,   117,    37,    38,   186,   187,   260,   311,   117,
      92,    20,   290,   206,   208,    16,  -125,   304,    14,    15,
      16,   210,   240,   211,   323,   284,   285,   269,   270,  -125,
     131,   271,    93,   272,    23,    24,   118,   150,   184,   322,
      94,    25,    26,    27,    28,    29,    30,    31,    32,    33,
     143,    34,    35,   226,   114,    36,    97,   305,   306,   329,
     194,   172,   338,   212,    37,    38,   307,   343,   186,   187,
      98,   173,   342,   262,    20,   100,   104,   105,   106,   190,
      76,   107,   335,   147,   148,   336,   200,   102,   216,    51,
     300,    47,   201,   301,   302,    52,    69,    72,    73,    75,
     224,   225,    77,   110,   215,    14,    15,   199,   113,   184,
     184,   321,   184,   116,   119,   121,   190,  -120,   269,   270,
    -120,   122,   271,    76,   272,    16,   117,   135,    16,   200,
     137,   138,    51,   194,    47,   201,   139,   331,    52,    69,
      72,    73,    75,    89,   151,    77,   280,   281,   -90,    25,
      26,    27,    28,    29,    30,    31,    32,    33,     9,   152,
      35,   154,   155,    36,    14,    15,   231,   153,   163,   159,
     156,   184,   232,   233,   162,   161,   166,    20,   308,   316,
      23,    89,   234,   235,   236,   237,   169,    25,    26,    27,
      28,    29,    30,    31,    32,    33,   238,    34,    35,   174,
     198,    36,   239,   219,   217,   315,   218,   228,   230,   220,
      37,    38,   222,   229,   266,   276,   282,   279,   289,   310,
     296,   286,   292,   294,   295,   298,     9,   297,   319,   240,
     318,   312,    14,    15,   231,   320,   313,   314,   324,   325,
     232,   233,   326,   327,   328,    20,   146,   339,    23,    89,
     234,   235,   236,   237,   344,    25,    26,    27,    28,    29,
      30,    31,    32,    33,   238,    34,    35,   332,   333,    36,
     239,   337,   340,   346,   227,     4,   278,   207,    37,    38,
       5,     6,     7,   209,     8,     9,    10,    11,    12,    13,
      62,    14,    15,    16,   259,   261,   142,   240,   277,   214,
     268,    17,    18,    19,    20,    21,    22,    23,    24,   317,
     160,   134,     0,     0,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     0,    34,    35,     0,     0,    36,    14,
      15,    16,     0,     0,     0,     0,     0,    37,    38,    39,
      40,    41,    42,    43,     0,    23,    24,     0,     0,     0,
       0,     0,    25,    26,    27,    28,    29,    30,    31,    32,
      33,     0,    34,    35,    16,     0,    36,     0,     0,     0,
       0,     0,     0,     0,     0,    37,    38,     0,     0,    89,
       0,     0,     0,     0,     0,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    16,     0,    35,     0,     0,    36,
       0,   176,   177,   178,   179,   180,     0,     0,     0,    89,
      16,     0,     0,     0,     0,    25,    26,    27,    28,    29,
      30,    31,    32,    33,   238,    89,    35,     0,     0,    36,
       0,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,     0,    35
};

static const short yycheck[] =
{
       6,     3,     8,     9,    10,    11,    12,    23,    24,    37,
       3,     3,     3,    91,    20,    21,     3,     3,     3,     3,
       3,    16,    16,     3,   132,    13,   217,   218,    17,   162,
      49,     8,    14,    15,    16,     0,    75,    14,    15,    16,
      16,    16,    81,    70,    71,    22,    23,    71,    36,   157,
      27,    70,   250,    30,    31,    32,    33,    34,    35,    13,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,   205,    89,    51,    52,   184,   155,    73,    73,
     278,    49,    49,    60,    61,    21,    22,    69,   279,    49,
      17,    27,    69,    69,    69,    16,    68,    18,    14,    15,
      16,    16,    79,    18,    71,   235,   236,    73,    74,    81,
      70,    77,    17,    79,    30,    31,    84,   123,   146,   303,
      17,    37,    38,    39,    40,    41,    42,    43,    44,    45,
     118,    47,    48,    69,    81,    51,    16,    58,    59,   323,
     156,    75,   332,    58,    60,    61,    67,   337,    21,    22,
      16,    85,   336,    69,    27,    16,    38,    39,    40,   151,
     162,    43,    72,    82,    83,    75,   159,    16,   174,   162,
      74,   162,   159,    77,    78,   162,   162,   162,   162,   162,
     186,   187,   162,    16,   172,    14,    15,    16,    16,   217,
     218,   299,   220,    16,    16,    15,   188,    72,    73,    74,
      75,    17,    77,   205,    79,    16,    49,    16,    16,   202,
      68,    68,   205,   229,   205,   202,    16,   325,   205,   205,
     205,   205,   205,    31,    68,   205,   232,   233,    74,    37,
      38,    39,    40,    41,    42,    43,    44,    45,     8,    16,
      48,    72,    74,    51,    14,    15,    16,    50,    16,    68,
      80,   279,    22,    23,    68,    70,    16,    27,   274,   287,
      30,    31,    32,    33,    34,    35,    76,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,     6,
      68,    51,    52,    72,    71,   287,    71,    16,    68,    75,
      60,    61,    76,    75,    51,    70,    36,    71,    16,    69,
      72,    80,    75,    70,    70,    76,     8,    72,    70,    79,
      71,    80,    14,    15,    16,    58,    80,    80,    70,    72,
      22,    23,    16,    72,    70,    27,    71,   333,    30,    31,
      32,    33,    34,    35,   340,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    70,    20,    51,
      52,    70,    19,     0,   188,     1,   230,   164,    60,    61,
       3,     4,     5,   167,     7,     8,     9,    10,    11,    12,
       3,    14,    15,    16,   199,   202,   117,    79,   229,   170,
     220,    24,    25,    26,    27,    28,    29,    30,    31,   288,
     134,   108,    -1,    -1,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    -1,    -1,    51,    14,
      15,    16,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,
      63,    64,    65,    66,    -1,    30,    31,    -1,    -1,    -1,
      -1,    -1,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    16,    -1,    51,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    31,
      -1,    -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    16,    -1,    48,    -1,    -1,    51,
      -1,    53,    54,    55,    56,    57,    -1,    -1,    -1,    31,
      16,    -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    31,    48,    -1,    -1,    51,
      -1,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    -1,    48
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,
   Copyright 1984, 1989, 1990, 2000, 2001 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
# ifdef alloca
#  define YYSTACK_USE_ALLOCA 1
# else /* alloca not defined */
#  ifdef __GNUC__
#   define YYSTACK_USE_ALLOCA 1
#   define alloca __builtin_alloca
#  else /* not GNU C.  */
#   if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#    define YYSTACK_USE_ALLOCA 1
#    include <alloca.h>
#   else /* not sparc */
     /* We think this test detects Watcom and Microsoft C.  */
     /* This used to test MSDOS, but that is a bad idea since that
	symbol is in the user namespace.  */
#    if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#     if 0
       /* No need for malloc.h, which pollutes the namespace; instead,
	  just don't use alloca.  */
#      include <malloc.h>
#     endif
#    else /* not MSDOS, or __TURBOC__ */
#     if defined(_AIX)
       /* I don't know what this was needed for, but it pollutes the
	  namespace.  So I turned it off.  rms, 2 May 1997.  */
       /* #include <malloc.h>  */
 #pragma alloca
#      define YYSTACK_USE_ALLOCA 1
#     else /* not MSDOS, or __TURBOC__, or _AIX */
#      if 0
	/* haible@ilog.fr says this works for HPUX 9.05 and up, and on
	   HPUX 10.  Eventually we can turn this on.  */
#       ifdef __hpux
#        define YYSTACK_USE_ALLOCA 1
#        define alloca __builtin_alloca
#  	endif /* __hpux */
#      endif
#     endif /* not _AIX */
#    endif /* not MSDOS, or __TURBOC__ */
#   endif /* not sparc */
#  endif /* not GNU C */
# endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#if YYSTACK_USE_ALLOCA
# define YYSTACK_ALLOC alloca
#else
# define YYSTACK_ALLOC malloc
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG
# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    fprintf Args;				\
} while (0)
/* Nonzero means print parse trace. [The following comment makes no
   sense to me.  Could someone clarify it?  --akim] Since this is
   uninitialized, it does not stop multiple parsers from coexisting.
   */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).  */
#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
# define __yy_memcpy(To, From, Count)	__builtin_memcpy (To, From, Count)
#else				/* not GNU C or C++ */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
# ifndef __cplusplus
__yy_memcpy (to, from, count)
     char *to;
     const char *from;
     unsigned int count;
# else /* __cplusplus */
__yy_memcpy (char *to, const char *from, unsigned int count)
# endif
{
  register const char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif

#line 212 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# ifdef __cplusplus
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else /* !__cplusplus */
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif /* !__cplusplus */
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define _YY_DECL_VARIABLES				\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
_YY_DECL_VARIABLES				\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
_YY_DECL_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yysv': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
# if YYLSP_NEEDED
  YYLTYPE yyloc;
# endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;
  
 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack. Use copies of
	 these so that the &'s don't force the real ones into memory.
	 */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#if YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of the
	 data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow ("parser stack overflow",
		  &yyss1, size * sizeof (*yyssp),
		  &yyvs1, size * sizeof (*yyvsp),
		  &yyls1, size * sizeof (*yylsp),
		  &yystacksize);
# else
      yyoverflow ("parser stack overflow",
		  &yyss1, size * sizeof (*yyssp),
		  &yyvs1, size * sizeof (*yyvsp),
		  &yystacksize);
# endif

      yyss = yyss1; yyvs = yyvs1;
# if YYLSP_NEEDED
      yyls = yyls1;
# endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror ("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
# if YYLSP_NEEDED
	      free (yyls);
# endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
# ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
# endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
# if YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
# endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#if YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %d\n", yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 227 "parser.y"
{
			/*
			 * We don't do these in parserEOF() because the parser
			 * is reading ahead and that would be too early.
			 */

			if (previousFile != NULL)
			{
				handleEOF();

				if (newContext.prevmod != NULL)
					handleEOM();

				free(previousFile);
				previousFile = NULL;
			}
	;
    break;}
case 15:
#line 256 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> hdrcode,yyvsp[0].codeb);
		;
    break;}
case 17:
#line 261 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> cppcode,yyvsp[0].codeb);
		;
    break;}
case 36:
#line 287 "parser.y"
{
			if (notSkipping())
			{
				yyvsp[0].memArg.nrderefs = 0;
				yyvsp[0].memArg.argflags = 0;

				currentMappedType = newMappedType(currentSpec,&yyvsp[0].memArg);
				usedInMainModule(currentSpec,currentMappedType -> iff);
			}
		;
    break;}
case 37:
#line 296 "parser.y"
{
			if (notSkipping())
			{
				if (currentMappedType -> convfromcode == NULL)
					yyerror("%MappedType must have a %ConvertFromTypeCode directive");

				if (currentMappedType -> convtocode == NULL)
					yyerror("%MappedType must have a %ConvertToTypeCode directive");

				currentMappedType = NULL;
			}
		;
    break;}
case 40:
#line 314 "parser.y"
{
			if (notSkipping())
				appendCodeBlock(&currentMappedType -> hdrcode,yyvsp[0].codeb);
		;
    break;}
case 41:
#line 318 "parser.y"
{
			if (notSkipping())
			{
				if (currentMappedType -> convfromcode != NULL)
					yyerror("%MappedType has more than one %ConvertFromTypeCode directive");

				currentMappedType -> convfromcode = yyvsp[0].codeb;
			}
		;
    break;}
case 42:
#line 327 "parser.y"
{
			if (notSkipping())
			{
				if (currentMappedType -> convtocode != NULL)
					yyerror("%MappedType has more than one %ConvertToTypeCode directive");

				currentMappedType -> convtocode = yyvsp[0].codeb;
			}
		;
    break;}
case 43:
#line 338 "parser.y"
{
			if (notSkipping())
			{
				classDef *ns;

				ns = newClass(currentSpec,namespace_iface,text2scopedName(yyvsp[0].text));
			
				setCannotCreate(ns);

				pushScope(ns);

				sectionFlags = 0;
			}
		;
    break;}
case 44:
#line 351 "parser.y"
{
			/* Remove the namespace name. */

			if (notSkipping())
				popScope();
		;
    break;}
case 47:
#line 363 "parser.y"
{
			qualDef *qd;

			for (qd = currentModule -> qualifiers; qd != NULL; qd = qd -> next)
				if (qd -> qtype == platform_qualifier)
					yyerror("%Platforms has already been defined for this module");
		;
    break;}
case 48:
#line 370 "parser.y"
{
			qualDef *qd;
			int nrneeded;

			/*
			 * Check that exactly one platform in the set was
			 * requested.
			 */

			nrneeded = 0;

			for (qd = currentModule -> qualifiers; qd != NULL; qd = qd -> next)
				if (qd -> qtype == platform_qualifier && isNeeded(qd))
					++nrneeded;

			if (nrneeded != 1)
				yyerror("Exactly one of these %Platforms must be specified with the -t flag");
		;
    break;}
case 51:
#line 394 "parser.y"
{
			newQualifier(currentSpec,currentModule,-1,yyvsp[0].text,platform_qualifier);
		;
    break;}
case 52:
#line 399 "parser.y"
{
			newQualifier(currentSpec,currentModule,-1,yyvsp[0].text,feature_qualifier);
		;
    break;}
case 53:
#line 404 "parser.y"
{
			if (currentModule -> nrTimeSlots >= 0)
				yyerror("%Timeline has already been defined for this module");

			currentModule -> nrTimeSlots = 0;
		;
    break;}
case 54:
#line 410 "parser.y"
{
			qualDef *qd;
			int nrneeded;

			/*
			 * Check that exactly one time slot in the set was
			 * requested.
			 */

			nrneeded = 0;

			for (qd = currentModule -> qualifiers; qd != NULL; qd = qd -> next)
				if (qd -> qtype == time_qualifier && isNeeded(qd))
					++nrneeded;

			if (nrneeded != 1)
				yyerror("Exactly one of this %Timeline must be specified with the -t flag");
		;
    break;}
case 57:
#line 434 "parser.y"
{
			newQualifier(currentSpec,currentModule,currentModule -> nrTimeSlots++,yyvsp[0].text,time_qualifier);
		;
    break;}
case 58:
#line 439 "parser.y"
{
			int skipNext;

			if (skipStackPtr >= MAX_NESTED_IF)
				yyerror("Internal error: increase the value of MAX_NESTED_IF");

			/* Nested %Ifs are implicit logical ands. */

			if (skipStackPtr > 0)
				yyvsp[-1].boolean = (yyvsp[-1].boolean && skipStack[skipStackPtr - 1]);

			skipStack[skipStackPtr++] = yyvsp[-1].boolean;
		;
    break;}
case 59:
#line 454 "parser.y"
{
			yyval.boolean = platOrFeature(currentSpec,yyvsp[0].text,FALSE);
		;
    break;}
case 60:
#line 457 "parser.y"
{
			yyval.boolean = platOrFeature(currentSpec,yyvsp[0].text,TRUE);
		;
    break;}
case 61:
#line 460 "parser.y"
{
			yyval.boolean = (platOrFeature(currentSpec,yyvsp[0].text,FALSE) || yyvsp[-2].boolean);
		;
    break;}
case 62:
#line 463 "parser.y"
{
			yyval.boolean = (platOrFeature(currentSpec,yyvsp[0].text,TRUE) || yyvsp[-3].boolean);
		;
    break;}
case 64:
#line 469 "parser.y"
{
			yyval.boolean = timePeriod(currentSpec,yyvsp[-2].text,yyvsp[0].text);
		;
    break;}
case 65:
#line 474 "parser.y"
{
			if (skipStackPtr-- <= 0)
				yyerror("Too many %End directives");
		;
    break;}
case 66:
#line 480 "parser.y"
{
			optFlag *of;

			if (yyvsp[0].optflags.nrFlags == 0)
				yyerror("%License details not specified");

			if ((of = findOptFlag(&yyvsp[0].optflags,"Type",string_flag)) == NULL)
				yyerror("%License type not specified");

			currentModule -> license = sipMalloc(sizeof (licenseDef));

			currentModule -> license -> type = of -> fvalue.sval;

			currentModule -> license -> licensee = 
				((of = findOptFlag(&yyvsp[0].optflags,"Licensee",string_flag)) != NULL)
					? of -> fvalue.sval : NULL;

			currentModule -> license -> timestamp = 
				((of = findOptFlag(&yyvsp[0].optflags,"Timestamp",string_flag)) != NULL)
					? of -> fvalue.sval : NULL;

			currentModule -> license -> sig = 
				((of = findOptFlag(&yyvsp[0].optflags,"Signature",string_flag)) != NULL)
					? of -> fvalue.sval : NULL;
		;
    break;}
case 67:
#line 507 "parser.y"
{
			/* Only bother if this is the main module. */

			if (isMainModule(currentModule))
			{
				expFuncDef *ef;

				/* Check it isn't already there. */

				for (ef = currentSpec -> exposed; ef != NULL; ef = ef -> next)
					if (strcmp(ef -> name,yyvsp[0].text) == 0)
						yyerror("Function has already been exposed in this module");

				ef = sipMalloc(sizeof (expFuncDef));

				ef -> name = yyvsp[0].text;
				ef -> next = currentSpec -> exposed;

				currentSpec -> exposed = ef;
			}
		;
    break;}
case 68:
#line 530 "parser.y"
{
			/* Check the module hasn't already been defined. */

			moduleDef *mod;

			for (mod = currentSpec -> moduleList; mod != NULL; mod = mod -> next)
				if (mod -> name != NULL && strcmp(mod -> name,yyvsp[0].text) == 0)
					yyerror("Module is already defined");

			currentModule -> name = yyvsp[0].text;
		;
    break;}
case 69:
#line 543 "parser.y"
{
			parseFile(NULL,yyvsp[0].text,NULL,FALSE);
		;
    break;}
case 70:
#line 548 "parser.y"
{
			parseFile(NULL,yyvsp[0].text,NULL,TRUE);
		;
    break;}
case 71:
#line 553 "parser.y"
{
			newImport(currentSpec,yyvsp[0].text);
		;
    break;}
case 72:
#line 558 "parser.y"
{
			yyval.codeb = NULL;
		;
    break;}
case 73:
#line 561 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		;
    break;}
case 74:
#line 566 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> copying,yyvsp[0].codeb);
		;
    break;}
case 75:
#line 572 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		;
    break;}
case 76:
#line 577 "parser.y"
{
			appendCodeBlock(&currentSpec -> exphdrcode,yyvsp[0].codeb);
		;
    break;}
case 77:
#line 582 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		;
    break;}
case 78:
#line 587 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> postinitcode,yyvsp[0].codeb);
		;
    break;}
case 79:
#line 593 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> prepycode,yyvsp[0].codeb);
		;
    break;}
case 80:
#line 599 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> pycode,yyvsp[0].codeb);
		;
    break;}
case 81:
#line 605 "parser.y"
{
			if (isMainModule(currentModule))
				appendCodeBlock(&currentSpec -> docs,yyvsp[0].codeb);
		;
    break;}
case 82:
#line 611 "parser.y"
{
			appendCodeBlock(&currentSpec -> docs,yyvsp[0].codeb);
		;
    break;}
case 83:
#line 616 "parser.y"
{
			if (isMainModule(currentModule))
			{
				mkTemplateDef *mtd;

				mtd = sipMalloc(sizeof (mkTemplateDef));

				mtd -> name = yyvsp[-2].text;

				if ((mtd -> objext = yyvsp[-1].text) == NULL)
					mtd -> objext = DEFAULT_OFILE_EXT;

				mtd -> templ = NULL;

				appendCodeBlock(&mtd -> templ,yyvsp[0].codeb);

				mtd -> next = currentSpec -> mktemplates;
				currentSpec -> mktemplates = mtd;
			}
		;
    break;}
case 85:
#line 641 "parser.y"
{
			if (notSkipping())
			{
				if (sectionFlags != 0 && (sectionFlags & ~(SECT_IS_PUBLIC | SECT_IS_PROT)) != 0)
					yyerror("Class enums must be in the public or protected sections");

				currentEnum = newEnum(currentSpec,currentModule,yyvsp[0].text,sectionFlags);
			}
		;
    break;}
case 87:
#line 652 "parser.y"
{
			yyval.text = NULL;
		;
    break;}
case 88:
#line 655 "parser.y"
{
			yyval.text = yyvsp[0].text;
		;
    break;}
case 89:
#line 660 "parser.y"
{
			yyval.text = NULL;
		;
    break;}
case 90:
#line 663 "parser.y"
{
			yyval.text = yyvsp[0].text;
		;
    break;}
case 95:
#line 674 "parser.y"
{
			if (notSkipping())
			{
				/*
				 * Note that we don't use the assigned value.
				 * This is a hangover from when enums where
				 * generated in Python.  We can remove it when
				 * we have got around to updating all the .sip
				 * files.
				 */

				enumValueDef *evd;

				evd = sipMalloc(sizeof (enumValueDef));

				evd -> name = cacheName(currentSpec,currentModule,yyvsp[-2].text);
				evd -> ed = currentEnum;

				checkAttributes(currentSpec,evd -> ed -> ecd,evd -> name,enum_attr);

				evd -> next = currentEnum -> values;
				currentEnum -> values = evd;

			}
		;
    break;}
case 98:
#line 705 "parser.y"
{
			yyval.valp = NULL;
		;
    break;}
case 99:
#line 708 "parser.y"
{
			yyval.valp = yyvsp[0].valp;
		;
    break;}
case 101:
#line 714 "parser.y"
{
			valueDef *vd;
 
			if (yyvsp[-2].valp -> vtype == string_value || yyvsp[0].valp -> vtype == string_value)
				yyerror("Invalid binary operator for string");
 
			/* Find the last value in the existing expression. */
 
			for (vd = yyvsp[-2].valp; vd -> next != NULL; vd = vd -> next)
				;
 
			vd -> vbinop = yyvsp[-1].qchar;
			vd -> next = yyvsp[0].valp;

			yyval.valp = yyvsp[-2].valp;
		;
    break;}
case 102:
#line 732 "parser.y"
{
			yyval.qchar = '-';
		;
    break;}
case 103:
#line 735 "parser.y"
{
			yyval.qchar = '+';
		;
    break;}
case 104:
#line 738 "parser.y"
{
			yyval.qchar = '|';
		;
    break;}
case 105:
#line 743 "parser.y"
{
			yyval.qchar = '\0';
		;
    break;}
case 106:
#line 746 "parser.y"
{
			yyval.qchar = '!';
		;
    break;}
case 107:
#line 749 "parser.y"
{
			yyval.qchar = '~';
		;
    break;}
case 108:
#line 752 "parser.y"
{
			yyval.qchar = '-';
		;
    break;}
case 109:
#line 755 "parser.y"
{
			yyval.qchar = '+';
		;
    break;}
case 110:
#line 760 "parser.y"
{
			if (yyvsp[-1].qchar != '\0' && yyvsp[0].value.vtype == string_value)
				yyerror("Invalid unary operator for string");
 
			/*
			 * Convert the value to a simple expression on the
			 * heap.
			 */
 
			yyval.valp = sipMalloc(sizeof (valueDef));
 
			*yyval.valp = yyvsp[0].value;
			yyval.valp -> vunop = yyvsp[-1].qchar;
			yyval.valp -> vbinop = '\0';
			yyval.valp -> next = NULL;
		;
    break;}
case 112:
#line 779 "parser.y"
{
			appendScopedName(&yyvsp[-2].scpvalp,yyvsp[0].scpvalp);
		;
    break;}
case 113:
#line 784 "parser.y"
{
			yyval.scpvalp = text2scopePart(yyvsp[0].text);
		;
    break;}
case 114:
#line 789 "parser.y"
{
			/*
			 * We let the C++ compiler decide if the value is a
			 * valid one - no point in building a full C++ parser
			 * here.
			 */

			yyval.value.vtype = scoped_value;
			yyval.value.u.vscp = yyvsp[0].scpvalp;
		;
    break;}
case 115:
#line 799 "parser.y"
{
			fcallDef *fcd;

			fcd = sipMalloc(sizeof (fcallDef));
			*fcd = yyvsp[-1].fcall;
			fcd -> name = yyvsp[-3].scpvalp;

			yyval.value.vtype = fcall_value;
			yyval.value.u.fcd = fcd;
		;
    break;}
case 116:
#line 809 "parser.y"
{
			yyval.value.vtype = real_value;
			yyval.value.u.vreal = yyvsp[0].real;
		;
    break;}
case 117:
#line 813 "parser.y"
{
			yyval.value.vtype = numeric_value;
			yyval.value.u.vnum = yyvsp[0].number;
		;
    break;}
case 118:
#line 817 "parser.y"
{
			yyval.value.vtype = string_value;
			yyval.value.u.vstr = yyvsp[0].text;
		;
    break;}
case 119:
#line 821 "parser.y"
{
			yyval.value.vtype = qchar_value;
			yyval.value.u.vqchar = yyvsp[0].qchar;
		;
    break;}
case 120:
#line 827 "parser.y"
{
			/* No values. */

			yyval.fcall.nrArgs = 0;
		;
    break;}
case 121:
#line 832 "parser.y"
{
			/* The single or first value. */

			yyval.fcall.args[0] = yyvsp[0].valp;
			yyval.fcall.nrArgs = 1;
		;
    break;}
case 122:
#line 838 "parser.y"
{
			/* Check that it wasn't ...(,value...). */

			if (yyval.fcall.nrArgs == 0)
				yyerror("First argument to function call is missing");

			/* Check there is room. */

			if (yyvsp[-2].fcall.nrArgs == MAX_NR_ARGS)
				yyerror("Too many arguments to function call");

			yyval.fcall = yyvsp[-2].fcall;

			yyval.fcall.args[yyval.fcall.nrArgs] = yyvsp[0].valp;
			yyval.fcall.nrArgs++;
		;
    break;}
case 123:
#line 856 "parser.y"
{
			if (notSkipping())
				newTypedef(currentSpec,yyvsp[-1].text,&yyvsp[-2].memArg);
		;
    break;}
case 124:
#line 862 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd;

				cd = newClass(currentSpec,class_iface,yyvsp[-1].scpvalp);

				usedInMainModule(currentSpec,cd -> iff);
				setCannotCreate(cd);
				setIsOpaque(cd);
			}
		;
    break;}
case 125:
#line 876 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd;

				cd = newClass(currentSpec,class_iface,text2scopedName(yyvsp[0].text));

				usedInMainModule(currentSpec,cd -> iff);
				setCannotCreate(cd);

				pushScope(cd);

				sectionFlags = SECT_IS_PUBLIC;
			}
		;
    break;}
case 126:
#line 890 "parser.y"
{
			if (notSkipping())
			{
				finishClass(currentScope(),&yyvsp[-4].optflags);
				popScope();
			}
		;
    break;}
case 127:
#line 899 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd;

				cd = newClass(currentSpec,class_iface,text2scopedName(yyvsp[0].text));

				usedInMainModule(currentSpec,cd -> iff);
				setCannotCreate(cd);

				pushScope(cd);

				sectionFlags = SECT_IS_PRIVATE;
			}
		;
    break;}
case 128:
#line 913 "parser.y"
{
			if (notSkipping())
			{
				finishClass(currentScope(),&yyvsp[-4].optflags);
				popScope();
			}
		;
    break;}
case 133:
#line 930 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd, *super;

				cd = currentScope();

				super = findClass(currentSpec,class_iface,yyvsp[0].scpvalp);

				appendToClassList(&cd -> supers,super);
				addToUsedList(&cd -> iff -> used,super -> iff);
			}
		;
    break;}
case 143:
#line 956 "parser.y"
{
			if (notSkipping())
				appendCodeBlock(&currentScope() -> cppcode,yyvsp[0].codeb);
		;
    break;}
case 144:
#line 960 "parser.y"
{
			if (notSkipping())
				appendCodeBlock(&currentScope() -> hdrcode,yyvsp[0].codeb);
		;
    break;}
case 148:
#line 967 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd = currentScope();

				if (cd -> convtosubcode != NULL)
					yyerror("Class has more than one %ConvertToSubClassCode directive");

				cd -> convtosubcode = yyvsp[0].codeb;
			}
		;
    break;}
case 149:
#line 978 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd = currentScope();

				if (cd -> convtocode != NULL)
					yyerror("Class has more than one %ConvertToTypeCode directive");

				cd -> convtocode = yyvsp[0].codeb;
			}
		;
    break;}
case 150:
#line 989 "parser.y"
{
			if (notSkipping())
				sectionFlags = SECT_IS_PUBLIC | yyvsp[-1].number;
		;
    break;}
case 151:
#line 993 "parser.y"
{
			if (notSkipping())
				sectionFlags = SECT_IS_PROT | yyvsp[-1].number;
		;
    break;}
case 152:
#line 997 "parser.y"
{
			if (notSkipping())
				sectionFlags = SECT_IS_PRIVATE | yyvsp[-1].number;
		;
    break;}
case 153:
#line 1001 "parser.y"
{
			if (notSkipping())
				sectionFlags = SECT_IS_SIGNAL;
		;
    break;}
case 154:
#line 1007 "parser.y"
{
			yyval.number = 0;
		;
    break;}
case 155:
#line 1010 "parser.y"
{
			yyval.number = SECT_IS_SLOT;
		;
    break;}
case 156:
#line 1015 "parser.y"
{
			if (notSkipping())
			{
				classDef *cd = currentScope();

				if (strcmp(classBaseName(cd),yyvsp[-4].text) != 0)
					yyerror("Destructor doesn't have the same name as its class");

				if (isDtor(cd))
					yyerror("Destructor has already been defined");

				cd -> dtorcode = yyvsp[0].codeb;
				setIsDtor(cd);

				if ((sectionFlags & SECT_IS_PUBLIC) == 0)
					setNoPublicDtor(cd);
			}
		;
    break;}
case 157:
#line 1035 "parser.y"
{
			if (notSkipping())
			{
				if ((sectionFlags & (SECT_IS_PUBLIC | SECT_IS_PROT | SECT_IS_PRIVATE)) == 0)
					yyerror("Constructor must be in the public, private or protected sections");

				newCtor(yyvsp[-6].text,sectionFlags,&yyvsp[-4].arglist,yyvsp[0].codeb);
			}

			free(yyvsp[-6].text);
		;
    break;}
case 158:
#line 1048 "parser.y"
{
			if (notSkipping())
			{
				if (sectionFlags != 0 && (sectionFlags & (SECT_IS_PUBLIC | SECT_IS_PROT | SECT_IS_PRIVATE | SECT_IS_SLOT | SECT_IS_SIGNAL)) == 0)
					yyerror("Class function must be in the public, private, protected, slot or signal sections");

				newFunction(currentSpec,currentModule,
					    sectionFlags,currentIsStatic,
					    currentOverIsVirt,
					    &yyvsp[-10].memArg,yyvsp[-9].text,&yyvsp[-7].arglist,yyvsp[-5].number,yyvsp[-4].number,&yyvsp[-3].optflags,yyvsp[-1].codeb,yyvsp[0].codeb);
			}

			currentIsStatic = FALSE;
			currentOverIsVirt = FALSE;
		;
    break;}
case 159:
#line 1066 "parser.y"
{
			yyval.number = FALSE;
		;
    break;}
case 160:
#line 1069 "parser.y"
{
			yyval.number = TRUE;
		;
    break;}
case 161:
#line 1074 "parser.y"
{
			yyval.number = 0;
		;
    break;}
case 162:
#line 1077 "parser.y"
{
			if (yyvsp[0].number != 0)
				yyerror("Abstract virtual function '= 0' expected");

			yyval.number = TRUE;
		;
    break;}
case 163:
#line 1085 "parser.y"
{
			yyval.optflags.nrFlags = 0;
		;
    break;}
case 164:
#line 1088 "parser.y"
{
			yyval.optflags = yyvsp[-1].optflags;
		;
    break;}
case 165:
#line 1094 "parser.y"
{
			yyval.optflags.flags[0] = yyvsp[0].flag;
			yyval.optflags.nrFlags = 1;
		;
    break;}
case 166:
#line 1098 "parser.y"
{
			/* Check there is room. */

			if (yyvsp[-2].optflags.nrFlags == MAX_NR_FLAGS)
				yyerror("Too many optional flags");

			yyval.optflags = yyvsp[-2].optflags;

			yyval.optflags.flags[yyval.optflags.nrFlags++] = yyvsp[0].flag;
		;
    break;}
case 167:
#line 1110 "parser.y"
{
			yyval.flag.ftype = bool_flag;
			yyval.flag.fname = yyvsp[0].text;
		;
    break;}
case 168:
#line 1114 "parser.y"
{
			yyval.flag = yyvsp[0].flag;
			yyval.flag.fname = yyvsp[-2].text;
		;
    break;}
case 169:
#line 1120 "parser.y"
{
			yyval.flag.ftype = name_flag;
			yyval.flag.fvalue.sval = yyvsp[0].text;
		;
    break;}
case 170:
#line 1124 "parser.y"
{
			yyval.flag.ftype = string_flag;
			yyval.flag.fvalue.sval = yyvsp[0].text;
		;
    break;}
case 171:
#line 1128 "parser.y"
{
			yyval.flag.ftype = integer_flag;
			yyval.flag.fvalue.ival = yyvsp[0].number;
		;
    break;}
case 172:
#line 1134 "parser.y"
{
			yyval.codeb = NULL;
		;
    break;}
case 173:
#line 1137 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		;
    break;}
case 174:
#line 1142 "parser.y"
{
			yyval.codeb = NULL;
		;
    break;}
case 175:
#line 1145 "parser.y"
{
			yyval.codeb = yyvsp[0].codeb;
		;
    break;}
case 176:
#line 1150 "parser.y"
{
			int a, nrsigs, nrrxcon, nrrxdis, nrslotcon, nrslotdis, nrarray, nrarraysize;

			nrsigs = nrrxcon = nrrxdis = nrslotcon = nrslotdis = nrarray = nrarraysize = 0;

			for (a = 0; a < yyvsp[0].arglist.nrArgs; ++a)
			{
				argDef *ad = &yyvsp[0].arglist.args[a];

				switch (ad -> atype)
				{
				case signal_type:
					++nrsigs;
					break;

				case rxcon_type:
					++nrrxcon;
					break;

				case rxdis_type:
					++nrrxdis;
					break;

				case slotcon_type:
					++nrslotcon;
					break;

				case slotdis_type:
					++nrslotdis;
					break;
				}

				if (isArray(ad))
					++nrarray;

				if (isArraySize(ad))
					++nrarraysize;
			}

			if (nrsigs == 1 && nrrxcon == 0)
				yyerror("SIP_SIGNAL can only be used with SIP_RXOBJ_CON");

			if (nrsigs > 1)
				yyerror("SIP_SIGNAL can only be given once");

			if (nrrxcon != nrslotcon || nrrxcon > 1)
				yyerror("SIP_RXOBJ_CON and SIP_SLOT_CON must both be given and at most once");

			if (nrrxdis != nrslotdis || nrrxdis > 1)
				yyerror("SIP_RXOBJ_DIS and SIP_SLOT_DIS must both be given and at most once");

			if (nrarray != nrarraysize || nrarray > 1)
				yyerror("/Array/ and /ArraySize/ must both be given and at most once");

			yyval.arglist = yyvsp[0].arglist;
		;
    break;}
case 177:
#line 1208 "parser.y"
{
			/* No arguments. */

			yyval.arglist.nrArgs = 0;
		;
    break;}
case 178:
#line 1213 "parser.y"
{
			/* The single or first argument. */

			yyval.arglist.args[0] = yyvsp[0].memArg;
			yyval.arglist.nrArgs = 1;
		;
    break;}
case 179:
#line 1219 "parser.y"
{
			/* Check that it wasn't ...(,arg...). */

			if (yyval.arglist.nrArgs == 0)
				yyerror("First argument of list is missing");

			/*
			 * If this argument has no default value, then all
			 * previous ones mustn't either.
			 */

			if (yyvsp[0].memArg.defval == NULL)
			{
				int a;

				for (a = 0; a < yyvsp[-2].arglist.nrArgs; ++a)
					if (yyvsp[-2].arglist.args[a].defval != NULL)
						yyerror("Compulsory argument given after optional argument");
			}

			/* Check there is room. */

			if (yyvsp[-2].arglist.nrArgs == MAX_NR_ARGS)
				yyerror("Internal error - increase the value of MAX_NR_ARGS");

			yyval.arglist = yyvsp[-2].arglist;

			yyval.arglist.args[yyval.arglist.nrArgs] = yyvsp[0].memArg;
			yyval.arglist.nrArgs++;
		;
    break;}
case 180:
#line 1251 "parser.y"
{
			yyval.memArg.atype = signal_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			currentSpec -> sigslots = TRUE;
		;
    break;}
case 181:
#line 1258 "parser.y"
{
			yyval.memArg.atype = rxcon_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			currentSpec -> sigslots = TRUE;
		;
    break;}
case 182:
#line 1265 "parser.y"
{
			yyval.memArg.atype = rxdis_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			currentSpec -> sigslots = TRUE;
		;
    break;}
case 183:
#line 1272 "parser.y"
{
			yyval.memArg.atype = slotcon_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			yyval.memArg.u.sa = sipMalloc(sizeof (funcArgs));
			*yyval.memArg.u.sa = yyvsp[-1].arglist;

			currentSpec -> sigslots = TRUE;
		;
    break;}
case 184:
#line 1282 "parser.y"
{
			yyval.memArg.atype = slotdis_type;
			yyval.memArg.argflags = 0;
			yyval.memArg.nrderefs = 0;

			yyval.memArg.u.sa = sipMalloc(sizeof (funcArgs));
			*yyval.memArg.u.sa = yyvsp[-1].arglist;

			currentSpec -> sigslots = TRUE;
		;
    break;}
case 185:
#line 1292 "parser.y"
{
			yyval.memArg = yyvsp[-1].memArg;
			yyval.memArg.defval = yyvsp[0].valp;
		;
    break;}
case 186:
#line 1298 "parser.y"
{currentIsStatic = TRUE;;
    break;}
case 191:
#line 1306 "parser.y"
{currentOverIsVirt = TRUE;;
    break;}
case 194:
#line 1310 "parser.y"
{
			if (notSkipping())
			{
				/* Check the section. */

				if (sectionFlags != 0)
				{
					if ((sectionFlags & SECT_IS_PUBLIC) == 0)
						yyerror("Class variables must be in the public section");

					if (!currentIsStatic && yyvsp[0].codeb != NULL)
						yyerror("%VariableCode cannot be specified for non-static class variables");
				}

				newVar(currentSpec,currentModule,yyvsp[-2].text,currentIsStatic,&yyvsp[-3].memArg,yyvsp[0].codeb);
			}

			currentIsStatic = FALSE;
		;
    break;}
case 195:
#line 1331 "parser.y"
{
			yyval.memArg = yyvsp[-2].memArg;
			yyval.memArg.nrderefs = yyvsp[-1].number;
			yyval.memArg.argflags = ARG_IS_CONST | yyvsp[0].number;
		;
    break;}
case 196:
#line 1336 "parser.y"
{
			yyval.memArg = yyvsp[-2].memArg;
			yyval.memArg.nrderefs = yyvsp[-1].number;
			yyval.memArg.argflags = yyvsp[0].number;
		;
    break;}
case 197:
#line 1343 "parser.y"
{
			yyval.memArg = yyvsp[-1].memArg;

			if (findOptFlag(&yyvsp[0].optflags,"Array",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_ARRAY;

			if (findOptFlag(&yyvsp[0].optflags,"ArraySize",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_ARRAY_SIZE;

			if (findOptFlag(&yyvsp[0].optflags,"Transfer",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_XFERRED;

			if (findOptFlag(&yyvsp[0].optflags,"TransferThis",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_THIS_XFERRED;

			if (findOptFlag(&yyvsp[0].optflags,"TransferBack",bool_flag) != NULL)
				yyval.memArg.argflags |= ARG_XFERRED_BACK;

			if (findOptFlag(&yyvsp[0].optflags,"Constrained",bool_flag) != NULL)
			{
				switch (yyval.memArg.atype)
				{
				case int_type:
					yyval.memArg.atype = cint_type;
					break;

				case float_type:
					yyval.memArg.atype = cfloat_type;
					break;

				case double_type:
					yyval.memArg.atype = cdouble_type;
					break;

				default:
					yyerror("/Constrained/ may not be specified for this type");
				}
			}
		;
    break;}
case 198:
#line 1384 "parser.y"
{
			yyval.number = 0;
		;
    break;}
case 199:
#line 1387 "parser.y"
{
			yyval.number = ARG_IS_REF;
		;
    break;}
case 200:
#line 1392 "parser.y"
{
			yyval.number = 0;
		;
    break;}
case 201:
#line 1395 "parser.y"
{
			yyval.number = yyvsp[-1].number + 1;
		;
    break;}
case 202:
#line 1400 "parser.y"
{
			yyval.memArg.atype = defined_type;
			yyval.memArg.u.snd = yyvsp[0].scpvalp;
		;
    break;}
case 203:
#line 1404 "parser.y"
{
			templateDef *td;

			td = sipMalloc(sizeof(templateDef));
			td -> fqname = yyvsp[-3].scpvalp;
			td -> types = yyvsp[-1].arglist;

			yyval.memArg.atype = template_type;
			yyval.memArg.u.td = td;
		;
    break;}
case 204:
#line 1414 "parser.y"
{
			yyval.memArg.atype = struct_type;
			yyval.memArg.u.sname = yyvsp[0].scpvalp;
		;
    break;}
case 205:
#line 1418 "parser.y"
{
			yyval.memArg.atype = ushort_type;
		;
    break;}
case 206:
#line 1421 "parser.y"
{
			yyval.memArg.atype = short_type;
		;
    break;}
case 207:
#line 1424 "parser.y"
{
			yyval.memArg.atype = uint_type;
		;
    break;}
case 208:
#line 1427 "parser.y"
{
			yyval.memArg.atype = uint_type;
		;
    break;}
case 209:
#line 1430 "parser.y"
{
			yyval.memArg.atype = int_type;
		;
    break;}
case 210:
#line 1433 "parser.y"
{
			yyval.memArg.atype = long_type;
		;
    break;}
case 211:
#line 1436 "parser.y"
{
			yyval.memArg.atype = ulong_type;
		;
    break;}
case 212:
#line 1439 "parser.y"
{
			yyval.memArg.atype = float_type;
		;
    break;}
case 213:
#line 1442 "parser.y"
{
			yyval.memArg.atype = double_type;
		;
    break;}
case 214:
#line 1445 "parser.y"
{
			yyval.memArg.atype = bool_type;
		;
    break;}
case 215:
#line 1448 "parser.y"
{
			yyval.memArg.atype = ustring_type;
		;
    break;}
case 216:
#line 1451 "parser.y"
{
			yyval.memArg.atype = string_type;
		;
    break;}
case 217:
#line 1454 "parser.y"
{
			yyval.memArg.atype = voidptr_type;
		;
    break;}
case 218:
#line 1457 "parser.y"
{
			yyval.memArg.atype = pyobject_type;
		;
    break;}
case 219:
#line 1462 "parser.y"
{
			/* The single or first type. */

			yyval.arglist.args[0] = yyvsp[0].memArg;
			yyval.arglist.nrArgs = 1;
		;
    break;}
case 220:
#line 1468 "parser.y"
{
			/* Check that it wasn't ,type... */

			if (yyval.arglist.nrArgs == 0)
				yyerror("First type of list is missing");

			/* Check there is room. */

			if (yyvsp[-2].arglist.nrArgs == MAX_NR_ARGS)
				yyerror("Internal error - increase the value of MAX_NR_ARGS");

			yyval.arglist = yyvsp[-2].arglist;

			yyval.arglist.args[yyval.arglist.nrArgs] = yyvsp[0].memArg;
			yyval.arglist.nrArgs++;
		;
    break;}
}

#line 606 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (int) (sizeof (yytname) / sizeof (char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen (yytname[x]) + 15, count++;
	  size += strlen ("parse error, unexpected `") + 1;
	  size += strlen (yytname[YYTRANSLATE (yychar)]);
	  msg = (char *) malloc (size);
	  if (msg != 0)
	    {
	      strcpy (msg, "parse error, unexpected `");
	      strcat (msg, yytname[YYTRANSLATE (yychar)]);
	      strcat (msg, "'");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (int) (sizeof (yytname) / sizeof (char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat (msg, count == 0 ? ", expecting `" : " or `");
			strcat (msg, yytname[x]);
			strcat (msg, "'");
			count++;
		      }
		}
	      yyerror (msg);
	      free (msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#if YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#if YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1486 "parser.y"



/*
 * Parse the specification.
 */

void parse(sipSpec *spec,FILE *fp,char *filename,char *cppMName,
	   stringList *tsl,stringList *xfl)
{
        /* Initialise the spec. */
 
	spec -> cppmname = cppMName;
	spec -> namecache = NULL;
	spec -> moduleList = NULL;
	spec -> ifacefiles = NULL;
	spec -> classes = NULL;
	spec -> mappedtypes = NULL;
	spec -> used = NULL;
	spec -> qobjclass = -1;
	spec -> exposed = NULL;
	spec -> enums = NULL;
	spec -> vars = NULL;
	spec -> othfuncs = NULL;
	spec -> overs = NULL;
	spec -> typedefs = NULL;
	spec -> copying = NULL;
	spec -> hdrcode = NULL;
	spec -> exphdrcode = NULL;
	spec -> cppcode = NULL;
	spec -> prepycode = NULL;
	spec -> pycode = NULL;
	spec -> docs = NULL;
	spec -> postinitcode = NULL;
	spec -> mktemplates = NULL;
	spec -> sigargs = NULL;
	spec -> sigslots = FALSE;

	currentSpec = spec;
	neededQualifiers = tsl;
	excludedQualifiers = xfl;
	currentModule = NULL;
	currentMappedType = NULL;
	currentOverIsVirt = FALSE;
	currentIsStatic = FALSE;
	previousFile = NULL;
	skipStackPtr = 0;
	currentScopeIdx = 0;
	sectionFlags = 0;

	newModule(fp,filename);
	spec -> module = currentModule;

	yyparse();

	handleEOF();
	handleEOM();
}


/*
 * Tell the parser that a complete file has now been read.
 */

void parserEOF(char *name,parserContext *pc)
{
	previousFile = sipStrdup(name);
	newContext = *pc;
}


/*
 * Append a class definition to a class list.  Append is needed specifically
 * for the list of super-classes because the order is important to Python.
 */

void appendToClassList(classList **clp,classDef *cd)
{
	classList *new;

	/* Find the end of the list. */

	while (*clp != NULL)
		clp = &(*clp) -> next;

	new = sipMalloc(sizeof (classList));

	new -> cd = cd;
	new -> next = NULL;

	*clp = new;
}


/*
 * Create a new module for the current specification and make it current.
 */

static void newModule(FILE *fp,char *filename)
{
	parseFile(fp,filename,currentModule,FALSE);

	currentModule = sipMalloc(sizeof (moduleDef));

	currentModule -> name = NULL;
	currentModule -> file = filename;
	currentModule -> qualifiers = NULL;
	currentModule -> nrTimeSlots = -1;
	currentModule -> license = NULL;
	currentModule -> next = currentSpec -> moduleList;

	currentSpec -> moduleList = currentModule;
}


/*
 * Switch to parsing a new file.
 */

static void parseFile(FILE *fp,char *name,moduleDef *prevmod,int optional)
{
	parserContext pc;

	pc.ifdepth = skipStackPtr;
	pc.prevmod = prevmod;

	setInputFile(fp,name,&pc,optional);
}


/*
 * Find an interface file, or create a new one.
 */

static ifaceFileDef *findIfaceFile(sipSpec *pt,scopedNameDef *fqname,
				   ifaceFileType iftype,argDef *ad)
{
	ifaceFileDef *iff;

	/* See if the name is already used. */

	for (iff = pt -> ifacefiles; iff != NULL; iff = iff -> next)
	{
		if (!sameScopedName(iff -> fqname,fqname))
			continue;

		/* They must be the same type. */

		if (iff -> type != iftype)
			yyerror("A class, namespace or mapped type has already been defined with the same name");

		/*
		 * If this is a mapped type with the same name defined in a
		 * different module, then check that this type isn't the same
		 * as any of the mapped types defined in that module.
		 */

		if (iftype == mappedtype_iface && iff -> module != currentModule)
		{
			mappedTypeDef *mtd;

			for (mtd = pt -> mappedtypes; mtd != NULL; mtd = mtd -> next)
			{
				if (mtd -> iff != iff)
					continue;

				if (ad -> atype != template_type ||
				    mtd -> type.atype != template_type ||
				    sameBaseType(ad,&mtd -> type,TRUE))
					yyerror("Mapped type has already been defined in another module");
			}

			/*
			 * If we got here then we have a mapped type based on
			 * an existing template, but with unique parameters.
			 * We don't want to use interface files from other
			 * modules, so skip this one.
			 */

			continue;
		}

		return iff;
	}

	iff = sipMalloc(sizeof (ifaceFileDef));

	iff -> name = cacheName(pt,currentModule,scopedNameTail(fqname));
	iff -> type = iftype;
	iff -> fqname = fqname;
	iff -> module = NULL;
	iff -> ifacefileflags = 0;
	iff -> used = NULL;
	iff -> next = pt -> ifacefiles;

	pt -> ifacefiles = iff;

	return iff;
}


/*
 * Find a class definition in a parse tree.
 */

static classDef *findClass(sipSpec *pt,ifaceFileType iftype,
			   scopedNameDef *fqname)
{
	classDef *cd;
	ifaceFileDef *iff;

	/* See if the name is already used. */

	iff = findIfaceFile(pt,fqname,iftype,NULL);

	for (cd = pt -> classes; cd != NULL; cd = cd -> next)
		if (cd -> iff == iff)
			return cd;

	/* Create a new one. */

	cd = sipMalloc(sizeof (classDef));

	cd -> iff = iff;
	cd -> next = pt -> classes;

	pt -> classes = cd;

	return cd;
}


/*
 * Add an interface file to an interface file list if it isn't already there.
 */

void addToUsedList(ifaceFileList **ifflp,ifaceFileDef *iff)
{
	ifaceFileList *iffl;

	while ((iffl = *ifflp) != NULL)
	{
		/* Don't bother if it is already there. */

		if (iffl -> iff == iff)
			return;

		ifflp = &iffl -> next;
	}

	setIsUsed(iff);

	iffl = sipMalloc(sizeof (ifaceFileList));

	iffl -> iff = iff;
	iffl -> next = NULL;

	*ifflp = iffl;
}


/*
 * Find an undefined (or create a new) class definition in a parse tree.
 */

static classDef *newClass(sipSpec *pt,ifaceFileType iftype,scopedNameDef *fqname)
{
	classDef *cd;

	cd = findClass(pt,iftype,fqname);

	/* Check it hasn't already been defined. */

	if (cd -> iff -> module != NULL)
	{
		/*
		 * Namespaces can be defined any number of times in the same
		 * module.
		 */

		if (iftype == namespace_iface && cd -> iff -> module == currentModule)
			return cd;

		yyerror(iftype == class_iface ?
			"The class has already been defined" :
			"The namespace has already been defined in another module");
	}

	cd -> iff -> module = currentModule;

	/* Complete the initialisation. */

	cd -> classflags = 0;
	cd -> classnr = -1;
	cd -> pyindent = -1;
	cd -> ecd = currentScope();
	cd -> supers = NULL;
	cd -> hierachy = NULL;
	cd -> ctors = NULL;
	cd -> dtorcode = NULL;
	cd -> members = NULL;
	cd -> overs = NULL;
	cd -> vmembers = NULL;
	cd -> visible = NULL;
	cd -> cppcode = NULL;
	cd -> hdrcode = (cd -> ecd != NULL ? cd -> ecd -> hdrcode : NULL);
	cd -> convtosubcode = NULL;
	cd -> subbase = NULL;
	cd -> convtocode = NULL;

	return cd;
}


/*
 * Tidy up after finishing a class definition.
 */

static void finishClass(classDef *cd,optFlags *optflgs)
{
	overDef *od;

	/* Handle any optional flags. */

	if (findOptFlag(optflgs,"CreatesThread",bool_flag) != NULL)
		setCreatesThread(cd);

	if (cd -> ctors == NULL)
	{
		/* Provide a default ctor. */

		cd -> ctors = sipMalloc(sizeof (ctorDef));
 
		cd -> ctors -> ctorflags = SECT_IS_PUBLIC;
		cd -> ctors -> args.nrArgs = 0;
		cd -> ctors -> cppcode = NULL;
		cd -> ctors -> next = NULL;

		resetCannotCreate(cd);
	}

	/* We can't create this class if it has private abstract functions. */

	for (od = cd -> overs; od != NULL; od = od -> next)
		if (isAbstract(od) && isPrivate(od))
		{
			setCannotCreate(cd);
			break;
		}
}


/*
 * Create a new mapped type.
 */

static mappedTypeDef *newMappedType(sipSpec *pt,argDef *ad)
{
	mappedTypeDef *mtd;
	scopedNameDef *snd;
	ifaceFileDef *iff;

	/* Check that the type is one we want to map. */

	switch (ad -> atype)
	{
	case defined_type:
		snd = ad -> u.snd;
		break;

	case template_type:
		snd = ad -> u.td -> fqname;
		break;

	case struct_type:
		snd = ad -> u.sname;
		break;

	default:
		yyerror("Invalid type for %MappedType");
	}

	iff = findIfaceFile(pt,snd,mappedtype_iface,ad);

	/* Check it hasn't already been defined. */

	for (mtd = pt -> mappedtypes; mtd != NULL; mtd = mtd -> next)
		if (mtd -> iff == iff)
		{
			/*
			 * We allow types based on the same template but with
			 * different arguments.
			 */

			if (ad -> atype != template_type ||
			    sameBaseType(ad,&mtd -> type,TRUE))
				yyerror("Mapped type has already been defined in this module");
		}

	/* The module may not have been set yet. */

	iff -> module = currentModule;

	/* Create a new mapped type. */

	mtd = sipMalloc(sizeof (mappedTypeDef));

	mtd -> type = *ad;
	mtd -> iff = iff;
	mtd -> hdrcode = NULL;
	mtd -> convfromcode = NULL;
	mtd -> convtocode = NULL;
	mtd -> next = pt -> mappedtypes;

	pt -> mappedtypes = mtd;

	return mtd;
}


/*
 * Create a new enum.
 */

static enumDef *newEnum(sipSpec *pt,moduleDef *mod,char *name,int flags)
{
	enumDef *ed;
	classDef *escope = currentScope();

	ed = sipMalloc(sizeof (enumDef));

	ed -> enumflags = flags;
	ed -> fqname = (name != NULL ? text2scopedName(name) : NULL);
	ed -> ecd = escope;
	ed -> module = mod;
	ed -> values = NULL;
	ed -> next = pt -> enums;

	pt -> enums = ed;

	if (escope != NULL)
		setHasEnums(escope);

	return ed;
}


/*
 * Create a new typedef.
 */

static void newTypedef(sipSpec *pt,char *name,argDef *type)
{
	typedefDef *td;
	scopedNameDef *fqname = text2scopedName(name);

	/* Check it doesn't already exist. */

	for (td = pt -> typedefs; td != NULL; td = td -> next)
		if (sameScopedName(td -> fqname,fqname))
		{
			fatalScopedName(fqname);
			fatal(" already defined\n");
		}

	td = sipMalloc(sizeof (typedefDef));

	td -> fqname = fqname;
	td -> ecd = currentScope();
	td -> type = *type;
	td -> next = pt -> typedefs;

	pt -> typedefs = td;
}


/*
 * Create a new variable.
 */

static void newVar(sipSpec *pt,moduleDef *mod,char *name,int isstatic,
		   argDef *type,codeBlock *code)
{
	varDef *var;
	classDef *escope = currentScope();
	nameDef *nd = cacheName(pt,mod,name);

	checkAttributes(pt,escope,nd,var_attr);

	var = sipMalloc(sizeof (varDef));

	var -> name = nd;
	var -> fqname = text2scopedName(name);
	var -> ecd = escope;
	var -> module = mod;
	var -> varflags = 0;
	var -> type = *type;
	var -> accessfunc = code;
	var -> next = pt -> vars;

	if (isstatic)
		setIsStaticVar(var);

	pt -> vars = var;
}


/*
 * Create a new ctor.
 */

static void newCtor(char *name,int sectFlags,funcArgs *args,codeBlock *code)
{
	ctorDef *ct, **ctp;
	classDef *cd = currentScope();

	/* Check the name of the constructor. */

	if (strcmp(classBaseName(cd),name) != 0)
		yyerror("Constructor doesn't have the same name as its class");

	/*
	 * Find the end of the list and, at the same time, check for any
	 * existing one with the same signature.
	 */

	for (ctp = &cd -> ctors; *ctp != NULL; ctp = &(*ctp) -> next)
		if (sameFuncArgs(&(*ctp) -> args,args,FALSE))
			yyerror("A constructor with the same Python signature has already been defined");

	/* Add to the list of constructors. */

	ct = sipMalloc(sizeof (ctorDef));

	ct -> ctorflags = sectFlags;
	ct -> args = *args;
	ct -> cppcode = code;
	ct -> next = NULL;

	if (isProtectedCtor(ct))
		setIsComplex(cd);

	if (!isPrivateCtor(ct))
		resetCannotCreate(cd);

	*ctp = ct;
}


/*
 * Create a new function.
 */

static void newFunction(sipSpec *pt,moduleDef *mod,int sflags,int isstatic,
			int isvirt,argDef *type,char *name,funcArgs *args,
			int isconst,int isabstract,optFlags *optflgs,
			codeBlock *mcode,codeBlock *vcode)
{
	classDef *cd = currentScope();
	char *pname;
	int a;
	overDef *od, **odp, **headp;
	optFlag *of;

	headp = (cd != NULL ?  &cd -> overs : &pt -> overs);

	/* Check /TransferThis/ wasn't specified. */

	for (a = 0; a < args -> nrArgs; ++a)
		if (isThisTransferred(&args -> args[a]))
			yyerror("/TransferThis/ may only be specified in constructors");

	/* Use the C++ name if a Python name wasn't given. */

	if ((of = findOptFlag(optflgs,"PyName",name_flag)) != NULL)
		pname = of -> fvalue.sval;
	else
		pname = name;

	/* Create a new overload definition. */

	od = sipMalloc(sizeof (overDef));

	/* Set the overload flags. */

	od -> overflags = sflags;

	if (isProtected(od))
		setIsComplex(cd);

	if ((isSlot(od) || isSignal(od)) && !isPrivate(od))
	{
		if (isSignal(od))
			setIsComplex(cd);

		pt -> sigslots = TRUE;
	}

	if (isSignal(od) && (mcode != NULL || vcode != NULL))
		yyerror("Cannot provide code for signals");

	if (isstatic)
	{
		if (isSlot(od) || isSignal(od))
			yyerror("Static functions cannot be slots or signals");

		if (isvirt)
			yyerror("Static functions cannot be virtual");

		setIsStatic(od);
	}

	if (isconst)
		setIsConst(od);

	if (isabstract)
	{
		if (sflags == 0)
			yyerror("Non-class function specified as abstract");

		setIsAbstract(od);
	}

	if ((of = findOptFlag(optflgs,"AutoGen",opt_name_flag)) != NULL)
	{
		setIsAutoGen(od);

		if (of -> fvalue.sval != NULL)
		{
			qualDef *qd;

			if ((qd = findQualifier(pt,of -> fvalue.sval)) == NULL || qd -> qtype != feature_qualifier)
				yyerror("No such feature");

			if (isExcluded(qd))
				resetIsAutoGen(od);
		}
	}

	if (isvirt)
	{
		if (isSignal(od))
			yyerror("Virtual signals aren't supported");

		setIsVirtual(od);
		setIsComplex(cd);
	}
	else if (vcode != NULL)
		yyerror("Virtual code provided for non-virtual function");

	od -> cppname = name;
	od -> args = *args;
	od -> cppcode = mcode;
	od -> virtcode = vcode;
	od -> common = findFunction(pt,mod,cd,pname);

	/* Methods that run in new threads must be virtual. */

	if (findOptFlag(optflgs,"NewThread",bool_flag) != NULL)
	{
		if (!isvirt)
			yyerror("/NewThread/ may only be specified for virtual methods");

		setIsNewThread(od);
	}

	/* Any overload being non-lazy makes all overloads non-lazy. */

	if (findOptFlag(optflgs,"NonLazy",bool_flag) != NULL)
		setIsNonLazy(od -> common);

	if ((of = findOptFlag(optflgs,"PreHook",name_flag)) != NULL)
		od -> prehook = of -> fvalue.sval;
	else
		od -> prehook = NULL;

	if ((of = findOptFlag(optflgs,"PostHook",name_flag)) != NULL)
		od -> posthook = of -> fvalue.sval;
	else
		od -> posthook = NULL;

	if (type -> atype == voidptr_type && type -> nrderefs == 0)
		od -> result = NULL;
	else
	{
		od -> result = sipMalloc(sizeof (argDef));
		*od -> result = *type;
	}

	od -> next = NULL;

	/*
	 * Find the end of the list and, at the same time, check for any
	 * existing one with the same signature.
	 */

	for (odp = headp; *odp != NULL; odp = &(*odp) -> next)
	{
		if ((*odp) -> common != od -> common)
			continue;

		if (!sameOverload(*odp,od,FALSE))
			continue;

		yyerror("A function with the same Python signature has already been defined");
	}

	*odp = od;
}


/*
 * Cache a name in a module.
 */

static nameDef *cacheName(sipSpec *pt,moduleDef *mod,char *name)
{
	nameDef *nd;

	/* See if it already exists. */

	for (nd = pt -> namecache; nd != NULL; nd = nd -> next)
		if (strcmp(nd -> text,name) == 0)
			return nd;

	/* Create a new one. */

	nd = sipMalloc(sizeof (nameDef));

	nd -> text = name;
	nd -> module = mod;
	nd -> next = pt -> namecache;

	pt -> namecache = nd;

	return nd;
}


/*
 * Find (or create) an overloaded function name.
 */

static memberDef *findFunction(sipSpec *pt,moduleDef *mod,classDef *cd,
			       char *pname)
{
	memberDef *md, **flist;
	nameDef *pnd;

	/* Cache the name. */

	pnd = cacheName(pt,mod,pname);

	/* Check there is no name clash. */

	checkAttributes(pt,cd,pnd,func_attr);

	/* See if it already exists. */

	flist = (cd != NULL ? &cd -> members : &pt -> othfuncs);

	for (md = *flist; md != NULL; md = md -> next)
		if (md -> pyname == pnd)
			return md;

	/* Create a new one. */

	md = sipMalloc(sizeof (memberDef));

	md -> pyname = pnd;
	md -> memberflags = 0;
	md -> module = mod;
	md -> next = *flist;

	*flist = md;

	return md;
}


/*
 * Search a set of flags for a particular one and check its type.
 */

static optFlag *findOptFlag(optFlags *flgs,char *name,flagType ft)
{
	int f;

	for (f = 0; f < flgs -> nrFlags; ++f)
	{
		optFlag *of = &flgs -> flags[f];

		if (strcmp(of -> fname,name) == 0)
		{
			/*
			 * An optional name can look like a boolean or a name.
			 */

			if (ft == opt_name_flag)
			{
				if (of -> ftype == bool_flag)
				{
					of -> ftype = opt_name_flag;
					of -> fvalue.sval = NULL;
				}
				else if (of -> ftype == name_flag)
					of -> ftype = opt_name_flag;
			}

			if (ft != of -> ftype)
				yyerror("Optional flag has a value of the wrong type");

			return of;
		}
	}

	return NULL;
}


/*
 * A name is going to be used as a Python attribute name within a Python scope
 * (ie. a Python dictionary), so check against what we already know is going in
 * the same scope in case there is a clash.
 */

static void checkAttributes(sipSpec *pt,classDef *pyscope,nameDef *attr,
			    attrType at)
{
	enumDef *ed;
	varDef *vd;
	classDef *cd;

	/* Check the enum values. */

	for (ed = pt -> enums; ed != NULL; ed = ed -> next)
	{
		enumValueDef *evd;

		if (ed -> ecd != pyscope)
			continue;

		for (evd = ed -> values; evd != NULL; evd = evd -> next)
			if (evd -> name == attr)
				yyerror("There is already an enum value in scope with the same Python name");
	}

	/* Check the variables. */

	for (vd = pt -> vars; vd != NULL; vd = vd -> next)
	{
		if (vd -> ecd != pyscope)
			continue;

		if (vd -> name != attr)
			continue;

		yyerror("There is already a variable in scope with the same Python name");
	}

	/*
	 * Only check the members if this attribute isn't a member because we
	 * can handle members with the same name in the same scope.
	 */

	if (at != func_attr)
	{
		memberDef *md, *membs;

		membs = (pyscope != NULL ? pyscope -> members : pt -> othfuncs);

		for (md = membs; md != NULL; md = md -> next)
		{
			overDef *od, *overs;

			if (md -> pyname != attr)
				continue;

			/* Check for a conflict with all overloads. */

			overs = (pyscope != NULL ? pyscope -> overs : pt -> overs);

			for (od = overs; od != NULL; od = od -> next)
			{
				if (od -> common != md)
					continue;

				yyerror("There is already a function in scope with the same Python name");
			}
		}
	}

	/* Check the classes. */

	for (cd = pt -> classes; cd != NULL; cd = cd -> next)
	{
		if (cd -> ecd != pyscope)
			continue;

		if (cd -> iff -> name != attr)
			continue;

		yyerror("There is already a class or namespace in scope with the same Python name");
	}
}


/*
 * Append a code block to a list of them.  Append is needed to give the
 * specifier easy control over the order of the documentation.
 */

static void appendCodeBlock(codeBlock **headp,codeBlock *new)
{
	while (*headp != NULL)
		headp = &(*headp) -> next;

	*headp = new;
}


/*
 * Handle the end of a fully parsed a file.
 */

static void handleEOF()
{
	/*
	 * Check that the number of nested if's is the same as when we started
	 * the file.
	 */

	if (skipStackPtr > newContext.ifdepth)
		fatal("Too many %%If statements in %s\n",previousFile);

	if (skipStackPtr < newContext.ifdepth)
		fatal("Too many %%End statements in %s\n",previousFile);
}


/*
 * Handle the end of a fully parsed a module.
 */

static void handleEOM()
{
	/* Check it has been named. */

	if (currentModule -> name == NULL)
		fatal("No %%Module has been specified for module defined in %s\n",previousFile);

	/* The previous module is now current. */

	currentModule = newContext.prevmod;
}


/*
 * Find an existing qualifier.
 */

static qualDef *findQualifier(sipSpec *pt,char *name)
{
	moduleDef *mod;

	for (mod = pt -> moduleList; mod != NULL; mod = mod -> next)
	{
		qualDef *qd;

		for (qd = mod -> qualifiers; qd != NULL; qd = qd -> next)
			if (strcmp(qd -> name,name) == 0)
				return qd;
	}

	return NULL;
}


/*
 * Return a copy of a scoped name.
 */

scopedNameDef *copyScopedName(scopedNameDef *snd)
{
	scopedNameDef *head;

	head = NULL;

	while (snd != NULL)
	{
		appendScopedName(&head,text2scopePart(snd -> name));
		snd = snd -> next;
	}

	return head;
}


/*
 * Append a name to a list of scopes.
 */

void appendScopedName(scopedNameDef **headp,scopedNameDef *newsnd)
{
	while (*headp != NULL)
		headp = &(*headp) -> next;

	*headp = newsnd;
}


/*
 * Free a scoped name - but not the text itself.
 */

void freeScopedName(scopedNameDef *snd)
{
	while (snd != NULL)
	{
		scopedNameDef *next = snd -> next;

		free(snd);

		snd = next;
	}
}


/*
 * Convert a text string to a scope part structure.
 */

scopedNameDef *text2scopePart(char *text)
{
	scopedNameDef *snd;

	snd = sipMalloc(sizeof (scopedNameDef));

	snd -> name = text;
	snd -> next = NULL;

	return snd;
}


/*
 * Convert a text string to a fully scoped name.
 */

static scopedNameDef *text2scopedName(char *text)
{
	classDef *cd = currentScope();
	scopedNameDef *snd;

	snd = (cd != NULL ? copyScopedName(cd -> iff -> fqname) : NULL);

	appendScopedName(&snd,text2scopePart(text));

	return snd;
}


/*
 * Return a pointer to the tail part of a scoped name.
 */

char *scopedNameTail(scopedNameDef *snd)
{
	if (snd == NULL)
		return NULL;

	while (snd -> next != NULL)
		snd = snd -> next;

	return snd -> name;
}


/*
 * Push the given scope onto the scope stack.
 */

static void pushScope(classDef *scope)
{
	if (currentScopeIdx >= MAX_NESTED_SCOPE)
		fatal("Internal error: increase the value of MAX_NESTED_SCOPE\n");

	scopeStack[currentScopeIdx] = scope;
	sectFlagsStack[currentScopeIdx] = sectionFlags;

	++currentScopeIdx;
}


/*
 * Pop the scope stack.
 */

static void popScope(void)
{
	if (currentScopeIdx > 0)
		sectionFlags = sectFlagsStack[currentScopeIdx--];
}


/*
 * Return non-zero if the current input should be parsed rather than be
 * skipped.
 */

static int notSkipping()
{
	return (skipStackPtr == 0 ? TRUE : skipStack[skipStackPtr - 1]);
}


/*
 * Return the value of an expression involving a time period.
 */

static int timePeriod(sipSpec *pt,char *lname,char *uname)
{
	int this;
	qualDef *qd, *lower, *upper;
	moduleDef *mod;

	if (lname == NULL)
		lower = NULL;
	else if ((lower = findQualifier(pt,lname)) == NULL || lower -> qtype != time_qualifier)
		yyerror("Lower bound is not a time version");

	if (uname == NULL)
		upper = NULL;
	else if ((upper = findQualifier(pt,uname)) == NULL || upper -> qtype != time_qualifier)
		yyerror("Upper bound is not a time version");

	/* Sanity checks on the bounds. */

	if (lower == NULL && upper == NULL)
		yyerror("Lower and upper bounds cannot both be omitted");

	if (lower != NULL && upper != NULL)
	{
		if (lower -> module != upper -> module)
			yyerror("Lower and upper bounds are from different timelines");

		if (lower == upper)
			yyerror("Lower and upper bounds must be different");

		if (lower -> order > upper -> order)
			yyerror("Later version specified as lower bound");
	}

	/* Go through each slot in the relevant timeline. */

	if (lower != NULL)
		mod = lower -> module;
	else
		mod = upper -> module;

	this = FALSE;

	for (qd = mod -> qualifiers; qd != NULL; qd = qd -> next)
	{
		if (qd -> qtype != time_qualifier)
			continue;

		if (lower != NULL && qd -> order < lower -> order)
			continue;

		if (upper != NULL && qd -> order >= upper -> order)
			continue;

		/*
		 * This is within the required range so if it is also needed
		 * then the expression is true.
		 */

		if (isNeeded(qd))
		{
			this = TRUE;
			break;
		}
	}

	return this;
}


/*
 * Return the value of an expression involving a single platform or feature.
 */

static int platOrFeature(sipSpec *pt,char *name,int optnot)
{
	int this;
	qualDef *qd;

	if ((qd = findQualifier(pt,name)) == NULL || qd -> qtype == time_qualifier)
		yyerror("No such platform or feature");

	/* Assume this sub-expression is false. */

	this = FALSE;

	if (qd -> qtype == feature_qualifier)
	{
		if (!isExcluded(qd))
			this = TRUE;
	}
	else if (isNeeded(qd))
		this = TRUE;

	if (optnot)
		this = !this;

	return this;
}


/*
 * Return TRUE if the given qualifier is excluded.
 */

static int isExcluded(qualDef *qd)
{
	stringList *sl;

	for (sl = excludedQualifiers; sl != NULL; sl = sl -> next)
		if (strcmp(qd -> name,sl -> s) == 0)
			return TRUE;

	return FALSE;
}


/*
 * Return TRUE if the given qualifier is needed.
 */

static int isNeeded(qualDef *qd)
{
	stringList *sl;

	for (sl = neededQualifiers; sl != NULL; sl = sl -> next)
		if (strcmp(qd -> name,sl -> s) == 0)
			return TRUE;

	return FALSE;
}


/*
 * Return the current scope.  currentScope() is only valid if notSkipping()
 * returns non-zero.
 */

static classDef *currentScope(void)
{
	return (currentScopeIdx > 0 ? scopeStack[currentScopeIdx - 1] : NULL);
}


/*
 * Create a new qualifier.
 */

static void newQualifier(sipSpec *pt,moduleDef *mod,int order,char *name,
			 qualType qt)
{
	qualDef *qd;

	/* Check it doesn't already exist. */

	if (findQualifier(pt,name) != NULL)
		yyerror("Version is already defined");

	qd = sipMalloc(sizeof (qualDef));

	qd -> name = name;
	qd -> qtype = qt;
	qd -> module = mod;
	qd -> order = order;
	qd -> next = mod -> qualifiers;

	mod -> qualifiers = qd;
}


/*
 * Create a new imported module.
 */

static void newImport(sipSpec *pt,char *name)
{
	/* Ignore if the file has already been imported. */

	moduleDef *mod;

	for (mod = pt -> moduleList; mod != NULL; mod = mod -> next)
		if (strcmp(mod -> file,name) == 0)
			return;

	newModule(NULL,name);
}


/*
 * If the use of an interface is by the main module, add it to the used list.
 */

static void usedInMainModule(sipSpec *pt,ifaceFileDef *iff)
{
	if (isMainModule(iff -> module))
		addToUsedList(&pt -> used,iff);
}
